<template>
  <div class="product">
    <navigation-bar />
    <div class="cart-list">
      <div class="cart-item" v-for="cart in $store.state.cartItems" :key="cart.id" @click="openItemDialog(cart)">
        <div class="cart-photos">
          <img class="cart-photo" :src="cart.photos[0]" alt="" />
        </div>
        <div class="cart-title">
          {{ cart.title }}
        </div>
        <div class="cart-tags">
          <div class="cart-tag" v-for="(tag, index) in cart.tags" :key="index">
            {{ tag }}
          </div>
        </div>
        <div class="cart-box">
          <button class="delete-to-cart-btn" @click.stop="deleteItem(cart.id)">Delete</button>
        </div>
      </div>
    </div>

    <product-dialog v-if="selectedItem" :product="selectedItem" @close="closeItemDialog" />
  </div>
</template>

<script lang="ts">
import { Vue, Component } from "vue-property-decorator";
import { Getter, Action } from 'vuex-class';
import ProductDialog from '@/components/ProductDialog.vue';
import NavigationBar from '@/components/NavigationBar.vue';

@Component({
  components: {
    'product-dialog': ProductDialog,
    'navigation-bar': NavigationBar,
  },
})
export default class Products extends Vue {
  @Getter('getCartItem') getCartItem!: () => any[];
  @Action('deleteProductFromCart') deleteProductFromCart!: () => void;

  private selectedItem: any = null;

  private openItemDialog(product: any) {
    this.selectedItem = product;
  }

  private closeItemDialog() {
    this.selectedItem = null;
  }

  private deleteItem(productId: any) {
    this.$store.dispatch('deleteProductFromCart', productId);
  }
}
</script>

<style scoped>
.cart-list {
  display: flex;
  flex-wrap: wrap;
  padding: 20px;
}

.cart-item {
  width: 300px;
  background-color: #fff;
  border: 1px solid #ddd;
  border-radius: 8px;
  margin: 10px;
  padding: 15px;
  cursor: pointer;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  transition: transform 0.3s ease-in-out;
}

.cart-title {
  font-size: 18px;
  font-weight: bold;
  margin-bottom: 8px;
}

.cart-photos {
  display: flex;
  justify-content: center;
  margin-bottom: 10px;
}

.cart-photo {
  max-width: 100%;
  height: auto;
}

.cart-tags {
  display: flex;
  flex-wrap: wrap;
}

.cart-tag {
  background-color: #eee;
  border-radius: 4px;
  padding: 4px 8px;
  margin-right: 8px;
  margin-bottom: 8px;
  font-size: 12px;
}

.cart-box {
  display: flex;
  justify-content: flex-end
}

.delete-to-cart-btn {
  background-color: #E53935;
  color: #fff;
  border: none;
  padding: 8px 16px;
  border-radius: 4px;
  cursor: pointer;
  transition: background-color 0.3s ease-in-out;
}
</style>
